package com.explause.AnnotationConfigExamples;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;
import org.springframework.context.annotation.Scope;

@Configuration
@Import({ AnotherBeanConfig.class })
public class BeanConfig {
	@Scope("singleton")
	@Bean(initMethod="initMethod", destroyMethod="destroyMethod")
	public HelloWorld hw(HelloWorld2 hw2) {
		HelloWorld hw = new HelloWorld(hw2);
		hw.setMessage("message in hw");
		return hw;
	}
	
	@Bean(initMethod="initMethod", destroyMethod="destroyMethod")
	public HelloWorld2 hw2() {
		HelloWorld2 hw2 = new HelloWorld2();
		hw2.setMessage("message1 in HelloWorld2");
		hw2.setMessage2("message2 in HelloWorld2");
		return hw2;
	}
	
	@Bean
	public HelloWorld2 hw3() {
		HelloWorld2 hw2 = new HelloWorld2();
		hw2.setMessage("message1 in HelloWorld3");
		hw2.setMessage2("message2 in HelloWorld3");
		return hw2;
	}
}