package com.explause.AnnotationConfigExamples;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;

public class AutowiredBean {
	@Autowired
	private HelloWorld hw;
	@Autowired
	@Qualifier("hw3")
	private HelloWorld2 hw2;
	
	public void setHelloWorld(HelloWorld hw) {
		this.hw = hw;
	}
	public void setHelloWorld2(HelloWorld2 hw2) {
		this.hw2 = hw2;
	}
	public HelloWorld getHelloWorld() {
		return hw;
	}
	public HelloWorld2 getHelloWorld2() {
		return hw2;
	}
	public void getMessages() {
		System.out.println("Inside the AutowiredBean.");
		hw.getMessage();
		hw2.getMessage();
	}
}
